/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_6 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_7 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_8 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_9 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_10 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern1 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern0 (x3, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern0 (x3, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x3, E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x3, E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return pattern3 (x3); /* [-1, 1] */
}

static int
pattern5 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern5 (x1, E_SImode); /* [-1, 1] */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern7 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode)
          || !register_operand (operands[2], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode)
          || !register_operand (operands[2], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern8 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_FCCmode)
      || GET_MODE (x1) != E_FCCmode)
    return -1;
  return pattern7 (); /* [-1, 1] */
}

static int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) != 0L)
        return -1;
      return pattern6 (x3); /* [-1, 2] */

    case REG:
    case SUBREG:
      operands[2] = x5;
      res = pattern8 (x3);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_FCCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_FCCmode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  return pattern7 (); /* [-1, 1] */
}

static int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH)
    return -1;
  return 0;
}

static int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern14 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

static int
pattern16 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern0 (x1, E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern0 (x1, E_DFmode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern0 (x1, E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern0 (x1, E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != USE)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != USE)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern17 (x2, E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern17 (x2, E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!symbolic_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

static int
pattern20 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_DImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

static int
pattern22 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!non_volatile_mem_operand (operands[1], E_HImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!non_volatile_mem_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

static int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 1
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

static int
pattern24 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != MEM)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != LO_SUM)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern24 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern24 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern26 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !symbolic_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !symbolic_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern28 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      return pattern28 (); /* [-1, 1] */

    case PC:
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      res = pattern28 ();
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern30 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern30 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !sle_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !sle_operand (operands[2], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !sle_operand (operands[2], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern34 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !uns_arith_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern35 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !reg_or_0_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !reg_or_0_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode)
      || !reg_or_0_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

static int
pattern38 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !arith_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !arith_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  return 0;
}

static int
pattern41 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!non_volatile_mem_operand (operands[1], E_HImode))
    return -1;
  x3 = PATTERN (peep2_next_insn (1));
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode
      || !register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!non_volatile_mem_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

static int
pattern42 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern43 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 64L:
      return pattern42 (x1, E_DImode, E_TImode); /* [-1, 0] */

    case 32L:
      if (pattern42 (x1, E_SImode, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern44 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !const_1_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_1_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern46 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_1_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern47 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern48 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern49 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern53 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern53 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern60 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern62 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern63 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern65 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern66 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_FCCmode
      || !register_operand (operands[1], E_FCCmode)
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern68 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern69 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern70 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern70 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern70 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern72 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern73 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern74 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i1)
      || !reg_or_0_operand (operands[5], i1))
    return -1;
  return 0;
}

static int
pattern75 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !scratch_operand (operands[6], i1))
    return -1;
  return 0;
}

static int
pattern76 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i1)
      || !reg_or_0_operand (operands[5], i1)
      || !scratch_operand (operands[7], i1))
    return -1;
  return 0;
}

static int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i1)
      || !reg_or_0_operand (operands[5], i1)
      || !scratch_operand (operands[7], i1)
      || !scratch_operand (operands[8], i1))
    return -1;
  return 0;
}

static int
pattern78 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !symbolic_operand (operands[2], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern65 (x2, E_SImode))
            {
            case 0:
              if (!
#line 1831 "../../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)))
                return -1;
              return 140; /* *seleqsi_using_si */

            case 1:
              if (!(
#line 1831 "../../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 340 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 144; /* *seleqsi_using_di */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern65 (x2, E_DImode))
            {
            case 0:
              if (!(
#line 1831 "../../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && 
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 142; /* *seleqdi_using_si */

            case 1:
              if (!(
#line 1831 "../../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && 
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 146; /* *seleqdi_using_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern65 (x2, E_SImode))
            {
            case 0:
              if (!
#line 1831 "../../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)))
                return -1;
              return 141; /* *selnesi_using_si */

            case 1:
              if (!(
#line 1831 "../../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 340 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 145; /* *selnesi_using_di */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern65 (x2, E_DImode))
            {
            case 0:
              if (!(
#line 1831 "../../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && 
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 143; /* *selnedi_using_si */

            case 1:
              if (!(
#line 1831 "../../../gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && 
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 147; /* *selnedi_using_di */

            default:
              return -1;
            }

        case E_SFmode:
          if (pattern66 (x2, E_SFmode) != 0
              || !
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 148; /* *selsf */

        case E_DFmode:
          if (pattern66 (x2, E_DFmode) != 0
              || !
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 149; /* *seldf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  res = recog_1 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!equality_operator (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_FCCmode))
    return -1;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case LABEL_REF:
      x7 = XEXP (x3, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      if (!
#line 2455 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 239; /* *branch_fp_FCCmode */

    case PC:
      x7 = XEXP (x3, 2);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!
#line 2471 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 240; /* *branch_fp_inverted_FCCmode */

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != ABS)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  x9 = XEXP (x2, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_CODE (x3))
    {
    case GT:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern67 (x2, E_SFmode) != 0
              || !
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 74; /* smaxasf3 */

        case E_DFmode:
          if (pattern67 (x2, E_DFmode) != 0
              || !
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 75; /* smaxadf3 */

        default:
          return -1;
        }

    case LT:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern67 (x2, E_SFmode) != 0
              || !
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 76; /* sminasf3 */

        case E_DFmode:
          if (pattern67 (x2, E_DFmode) != 0
              || !
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 77; /* sminadf3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode)
          || !
#line 1596 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[0], INTVAL (operands[1]),
			    INTVAL (operands[2]))))
        return -1;
      return 128; /* *insvsi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode)
          || !(
#line 1596 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[0], INTVAL (operands[1]),
			    INTVAL (operands[2]))) && 
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
        return -1;
      return 129; /* *insvdi */

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !move_operand (operands[1], E_DImode))
        return -1;
      if (
#line 1630 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
        return 130; /* *movdi_32bit */
      if (!
#line 1640 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
        return -1;
      return 131; /* *movdi_64bit */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !move_operand (operands[1], E_SImode)
          || !
#line 1661 "../../../gcc/config/loongarch/loongarch.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))))
        return -1;
      return 132; /* *movsi_internal */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !move_operand (operands[1], E_HImode)
          || !
#line 1686 "../../../gcc/config/loongarch/loongarch.md"
((register_operand (operands[0], HImode)
       || reg_or_0_operand (operands[1], HImode))))
        return -1;
      return 133; /* *movhi_internal */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !move_operand (operands[1], E_QImode)
          || !
#line 1711 "../../../gcc/config/loongarch/loongarch.md"
((register_operand (operands[0], QImode)
       || reg_or_0_operand (operands[1], QImode))))
        return -1;
      return 134; /* *movqi_internal */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !move_operand (operands[1], E_SFmode))
        return -1;
      if (
#line 1731 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))))
        return 135; /* *movsf_hardfloat */
      if (!
#line 1741 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_SOFT_FLOAT
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))))
        return -1;
      return 136; /* *movsf_softfloat */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !move_operand (operands[1], E_DFmode))
        return -1;
      if (
#line 1762 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
        return 137; /* *movdf_hardfloat */
      if (!
#line 1772 "../../../gcc/config/loongarch/loongarch.md"
((TARGET_SOFT_FLOAT || TARGET_SINGLE_FLOAT)
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
        return -1;
      return 138; /* *movdf_softfloat */

    default:
      return -1;
    }
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 2:
      switch (XINT (x2, 1))
        {
        case 10:
          switch (pattern18 (x1))
            {
            case 0:
              if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 70; /* fmaxsf3 */

            case 1:
              if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 71; /* fmaxdf3 */

            default:
              return -1;
            }

        case 11:
          switch (pattern18 (x1))
            {
            case 0:
              if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 72; /* fminsf3 */

            case 1:
              if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 73; /* fmindf3 */

            default:
              return -1;
            }

        case 26:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern47 (x2, E_SImode) != 0
                  || !
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return -1;
              return 162; /* ori_l_lo12si */

            case E_DImode:
              if (pattern47 (x2, E_DImode) != 0
                  || !
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return -1;
              return 163; /* ori_l_lo12di */

            default:
              return -1;
            }

        case 28:
          if (pattern19 (x1) != 0
              || !
#line 1980 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 164; /* lui_h_lo20 */

        case 29:
          if (pattern19 (x1) != 0
              || !
#line 1990 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 165; /* lui_h_hi12 */

        case 4:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern48 (x2, E_DFmode, E_SImode) != 0
                  || !(
#line 2025 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 377 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 171; /* load_highdf */

            case E_DImode:
              if (pattern48 (x2, E_DImode, E_SImode) != 0
                  || !(
#line 2025 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 378 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 172; /* load_highdi */

            case E_TFmode:
              if (pattern48 (x2, E_TFmode, E_DImode) != 0
                  || !(
#line 2025 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 379 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 173; /* load_hightf */

            default:
              return -1;
            }

        case 5:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode))
                return -1;
              switch (pattern50 (x2))
                {
                case 0:
                  if (!(
#line 2040 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 377 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 174; /* store_worddf */

                case 1:
                  if (!(
#line 2040 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 378 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 175; /* store_worddi */

                default:
                  return -1;
                }

            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 2040 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 379 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 176; /* store_wordtf */

            default:
              return -1;
            }

        case 6:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern49 (x2, E_DFmode, E_SImode) != 0
                  || !(
#line 2097 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 377 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 185; /* movgr2frhdf */

            case E_DImode:
              if (pattern49 (x2, E_DImode, E_SImode) != 0
                  || !(
#line 2097 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 378 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 186; /* movgr2frhdi */

            case E_TFmode:
              if (pattern49 (x2, E_TFmode, E_DImode) != 0
                  || !(
#line 2097 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 379 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 187; /* movgr2frhtf */

            default:
              return -1;
            }

        case 21:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != MEM
              || GET_MODE (x3) != E_BLKmode)
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != SCRATCH)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[0] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 350; /* stack_tiesi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 351; /* stack_tiedi */

            default:
              return -1;
            }

        case 22:
          switch (pattern20 (x1))
            {
            case 0:
              return 358; /* loongarch_crc_w_b_w */

            case 1:
              return 359; /* loongarch_crc_w_h_w */

            case 2:
              return 360; /* loongarch_crc_w_w_w */

            case 3:
              return 361; /* loongarch_crc_w_d_w */

            default:
              return -1;
            }

        case 23:
          switch (pattern20 (x1))
            {
            case 0:
              return 362; /* loongarch_crcc_w_b_w */

            case 1:
              return 363; /* loongarch_crcc_w_h_w */

            case 2:
              return 364; /* loongarch_crcc_w_w_w */

            case 3:
              return 365; /* loongarch_crcc_w_d_w */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 30:
          switch (pattern25 (x2))
            {
            case 0:
              if (!(
#line 1925 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_EXPLICIT_RELOCS) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                return -1;
              return 154; /* tls_lowsi */

            case 1:
              if (!(
#line 1925 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_EXPLICIT_RELOCS) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                return -1;
              return 155; /* tls_lowdi */

            default:
              return -1;
            }

        case 24:
          switch (pattern25 (x2))
            {
            case 0:
              if (!(
#line 1943 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_EXPLICIT_RELOCS) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                return -1;
              return 156; /* ld_from_gotsi */

            case 1:
              if (!(
#line 1943 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_EXPLICIT_RELOCS) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                return -1;
              return 157; /* ld_from_gotdi */

            default:
              return -1;
            }

        case 27:
          switch (pattern26 (x2))
            {
            case 0:
              if (!
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return -1;
              return 158; /* lui_l_hi20si */

            case 1:
              if (!
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return -1;
              return 159; /* lui_l_hi20di */

            default:
              return -1;
            }

        case 25:
          switch (pattern26 (x2))
            {
            case 0:
              if (!
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return -1;
              return 160; /* pcalau12isi */

            case 1:
              if (!
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return -1;
              return 161; /* pcalau12idi */

            default:
              return -1;
            }

        case 8:
          switch (pattern27 (x2))
            {
            case 0:
              if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 166; /* frint_s */

            case 1:
              if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 167; /* frint_d */

            default:
              return -1;
            }

        case 3:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !general_operand (operands[1], E_SImode)
                  || !(
#line 2010 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 377 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 168; /* load_lowdf */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !general_operand (operands[1], E_SImode)
                  || !(
#line 2010 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 378 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 169; /* load_lowdi */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || GET_MODE (x2) != E_TFmode
                  || !general_operand (operands[1], E_DImode)
                  || !(
#line 2010 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 379 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 170; /* load_lowtf */

            default:
              return -1;
            }

        case 17:
          switch (pattern26 (x2))
            {
            case 0:
              if (!
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return -1;
              return 177; /* got_load_tls_gdsi */

            case 1:
              if (!
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return -1;
              return 178; /* got_load_tls_gddi */

            default:
              return -1;
            }

        case 18:
          switch (pattern26 (x2))
            {
            case 0:
              if (!
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return -1;
              return 179; /* got_load_tls_ldsi */

            case 1:
              if (!
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return -1;
              return 180; /* got_load_tls_lddi */

            default:
              return -1;
            }

        case 19:
          switch (pattern26 (x2))
            {
            case 0:
              if (!
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return -1;
              return 181; /* got_load_tls_lesi */

            case 1:
              if (!
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return -1;
              return 182; /* got_load_tls_ledi */

            default:
              return -1;
            }

        case 20:
          switch (pattern26 (x2))
            {
            case 0:
              if (!
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return -1;
              return 183; /* got_load_tls_iesi */

            case 1:
              if (!
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return -1;
              return 184; /* got_load_tls_iedi */

            default:
              return -1;
            }

        case 7:
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode))
                return -1;
              switch (pattern50 (x2))
                {
                case 0:
                  if (!(
#line 2107 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 377 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 188; /* movfrh2grdf */

                case 1:
                  if (!(
#line 2107 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 378 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 189; /* movfrh2grdi */

                default:
                  return -1;
                }

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 2107 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 379 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 190; /* movfrh2grtf */

            default:
              return -1;
            }

        case 0:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 236; /* revb_2h */

        case 1:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode)
              || !
#line 2427 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 237; /* revb_4h */

        case 2:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode)
              || !
#line 2434 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 238; /* revh_d */

        case 9:
          switch (pattern27 (x2))
            {
            case 0:
              if (!
#line 3205 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 344; /* fclass_s */

            case 1:
              if (!(
#line 3205 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 345; /* fclass_d */

            default:
              return -1;
            }

        case 15:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 348; /* bitrev_4b */

        case 16:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode))
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 349; /* bitrev_8b */

        default:
          return -1;
        }

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x7 = XVECEXP (x2, 0, 2);
      operands[3] = x7;
      switch (XINT (x2, 1))
        {
        case 13:
          if (pattern51 (x2, E_SImode) != 0
              || !const_0_to_3_operand (operands[3], E_SImode))
            return -1;
          return 346; /* bytepick_w */

        case 14:
          if (pattern51 (x2, E_DImode) != 0
              || !const_0_to_7_operand (operands[3], E_DImode))
            return -1;
          return 347; /* bytepick_d */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FMA:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case NEG:
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern61 (x3, E_SFmode) != 0
                      || !(
#line 883 "../../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 46; /* *fmasf4 */

                case E_DFmode:
                  if (pattern61 (x3, E_DFmode) != 0
                      || !(
#line 883 "../../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 47; /* *fmadf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern62 (x3, E_SFmode) != 0
                      || !(
#line 896 "../../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 48; /* *fmssf4 */

                case E_DFmode:
                  if (pattern62 (x3, E_DFmode) != 0
                      || !(
#line 896 "../../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 49; /* *fmsdf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern63 (x3, E_SFmode) != 0
                      || !
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 50; /* *fnmssf4 */

                case E_DFmode:
                  if (pattern63 (x3, E_DFmode) != 0
                      || !
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                    return -1;
                  return 51; /* *fnmsdf4 */

                default:
                  return -1;
                }

            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern64 (x3, E_SFmode) != 0
                      || !
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 52; /* *fnmasf4 */

                case E_DFmode:
                  if (pattern64 (x3, E_DFmode) != 0
                      || !
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                    return -1;
                  return 53; /* *fnmadf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 78; /* negsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 79; /* negdi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 82; /* negsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 83; /* negdf2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 15:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 193; /* loongarch_cpucfg */

        case 13:
          if (!const_uimm5_operand (operands[1], E_VOIDmode)
              || !
#line 3190 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 342; /* loongarch_movfcsr2gr */

        default:
          return -1;
        }

    case 3:
      if (XINT (x3, 1) != 12)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern60 (x3, E_SImode) != 0
              || !
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 314; /* probe_stack_rangesi */

        case E_DImode:
          if (pattern60 (x3, E_DImode) != 0
              || !
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 315; /* probe_stack_rangedi */

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 42:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!memory_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !reg_or_0_operand (operands[1], E_SImode))
                return -1;
              return 367; /* atomic_storesi */

            case E_DImode:
              if (!memory_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !reg_or_0_operand (operands[1], E_DImode)
                  || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 368; /* atomic_storedi */

            default:
              return -1;
            }

        case 40:
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case PLUS:
              switch (pattern54 (x3))
                {
                case 0:
                  return 369; /* atomic_addsi */

                case 1:
                  if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 373; /* atomic_adddi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern54 (x3))
                {
                case 0:
                  return 370; /* atomic_orsi */

                case 1:
                  if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 374; /* atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern54 (x3))
                {
                case 0:
                  return 371; /* atomic_xorsi */

                case 1:
                  if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 375; /* atomic_xordi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern54 (x3))
                {
                case 0:
                  return 372; /* atomic_andsi */

                case 1:
                  if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 376; /* atomic_anddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          if (register_operand (operands[1], E_SImode)
              && uns_arith_operand (operands[2], E_SImode))
            return 84; /* andsi3 */
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !low_bitmask_operand (operands[2], E_SImode))
            return -1;
          return 90; /* andsi3_extended */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          if (register_operand (operands[1], E_DImode)
              && uns_arith_operand (operands[2], E_DImode)
              && 
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return 87; /* anddi3 */
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !low_bitmask_operand (operands[2], E_DImode)
              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 91; /* anddi3_extended */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NOT:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern52 (x3, E_SImode) != 0)
                return -1;
              return 93; /* *norsi3 */

            case E_DImode:
              if (pattern52 (x3, E_DImode) != 0
                  || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 94; /* *nordi3 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern31 (x3))
            {
            case 0:
              return 95; /* andnsi */

            case 1:
              if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 97; /* andndi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern21 (x3) != 0)
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!const_immalsl_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!immediate_operand (operands[3], E_VOIDmode)
          || !
#line 2354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && ((INTVAL (operands[3]) >> INTVAL (operands[2])) == 0xffffffff)))
        return -1;
      return 229; /* zero_extend_ashift */

    default:
      return -1;
    }
}

static int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern13 (x3) != 0
          || !
#line 565 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 6; /* *addsi3_extended */

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 603 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 11; /* *subsi3_extended */

    case MULT:
      if (pattern14 (x3, E_SImode) != 0
          || !
#line 648 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 17; /* *mulsi3_extended */

    case DIV:
      if (pattern14 (x3, E_DImode) != 0)
        return -1;
      return 34; /* divdi3_fake */

    case UDIV:
      if (pattern14 (x3, E_DImode) != 0)
        return -1;
      return 35; /* udivdi3_fake */

    case MOD:
      if (pattern14 (x3, E_DImode) != 0)
        return -1;
      return 36; /* moddi3_fake */

    case UMOD:
      if (pattern14 (x3, E_DImode) != 0)
        return -1;
      return 37; /* umoddi3_fake */

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern15 (x3))
        {
        case 0:
          if (!
#line 1281 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 111; /* extendsidi2 */

        case 1:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 113; /* extendqidi2 */

        case 2:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 115; /* extendhidi2 */

        case 3:
          return 112; /* extendqisi2 */

        case 4:
          return 114; /* extendhisi2 */

        case 5:
          return 116; /* extendqihi2 */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern13 (x3) != 0
          || !
#line 2322 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 224; /* *ashlsi3_extend */

    case ASHIFTRT:
      if (pattern13 (x3) != 0
          || !
#line 2322 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 225; /* *ashrsi3_extend */

    case LSHIFTRT:
      if (pattern13 (x3) != 0
          || !
#line 2322 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 226; /* *lshrsi3_extend */

    default:
      return -1;
    }
}

static int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern0 (x3, E_SFmode) != 0
                  || !
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2; /* addsf3 */

            case E_DFmode:
              if (pattern0 (x3, E_DFmode) != 0
                  || !
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 3; /* adddf3 */

            case E_SImode:
              if (pattern39 (x3, E_SImode) != 0)
                return -1;
              return 4; /* addsi3 */

            case E_DImode:
              if (pattern39 (x3, E_DImode) != 0
                  || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 5; /* adddi3 */

            default:
              return -1;
            }

        case AND:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != ASHIFT
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[3] = x8;
          if (!const_immalsl_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x5, 1);
          operands[4] = x9;
          if (!immediate_operand (operands[4], E_VOIDmode)
              || !
#line 2367 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && ((INTVAL (operands[4]) >> INTVAL (operands[3])) == 0xffffffff)))
            return -1;
          return 230; /* bstrpick_alsl_paired */

        default:
          return -1;
        }

    case ASHIFT:
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x11 = XEXP (x4, 1);
      operands[2] = x11;
      if (!const_immalsl_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern55 (x3, E_SImode) != 0)
            return -1;
          return 231; /* alslsi3 */

        case E_DImode:
          if (pattern55 (x3, E_DImode) != 0
              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 232; /* alsldi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern56 (x3, E_SFmode) != 0
                  || !
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 38; /* fmasf4 */

            case E_DFmode:
              if (pattern56 (x3, E_DFmode) != 0
                  || !
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 39; /* fmadf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern57 (x3, E_SFmode) != 0
                  || !
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 40; /* fmssf4 */

            case E_DFmode:
              if (pattern57 (x3, E_DFmode) != 0
                  || !
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 41; /* fmsdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern58 (x3, E_SFmode) != 0
                  || !(
#line 852 "../../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 42; /* fnmasf4 */

            case E_DFmode:
              if (pattern58 (x3, E_DFmode) != 0
                  || !(
#line 852 "../../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 43; /* fnmadf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern59 (x3, E_SFmode) != 0
                  || !(
#line 870 "../../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 44; /* fnmssf4 */

            case E_DFmode:
              if (pattern59 (x3, E_DFmode) != 0
                  || !(
#line 870 "../../../gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 45; /* fnmsdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern15 (x3))
        {
        case 0:
          if (!
#line 1203 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 100; /* *zero_extendsidi2_internal */

        case 1:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 102; /* zero_extendqidi2 */

        case 2:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 104; /* zero_extendhidi2 */

        case 3:
          return 101; /* zero_extendqisi2 */

        case 4:
          return 103; /* zero_extendhisi2 */

        case 5:
          return 105; /* zero_extendqihi2 */

        default:
          return -1;
        }

    case TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!
#line 1256 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 106; /* *zero_extendsi_truncqi */

            case E_HImode:
              if (!
#line 1256 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 108; /* *zero_extendsi_trunchi */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!
#line 1256 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 107; /* *zero_extenddi_truncqi */

            case E_HImode:
              if (!
#line 1256 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 109; /* *zero_extenddi_trunchi */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode
              || !
#line 1265 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 110; /* *zero_extendhi_truncqi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern34 (x3, E_SImode) != 0)
            return -1;
          return 85; /* iorsi3 */

        case E_DImode:
          if (pattern34 (x3, E_DImode) != 0
              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 88; /* iordi3 */

        case E_HImode:
          if (pattern34 (x3, E_HImode) != 0)
            return -1;
          return 92; /* *iorhi3 */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (pattern31 (x3))
        {
        case 0:
          return 96; /* iornsi */

        case 1:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 98; /* iorndi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_lu32i_operand (operands[2], E_DImode)
          || !
#line 1891 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 150; /* lu32i_d */

    case AND:
      if (pattern21 (x3) != 0)
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!lu52i_mask_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!const_lu52i_operand (operands[3], E_VOIDmode)
          || !
#line 1902 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 151; /* lu52i_d */

    default:
      return -1;
    }
}

static int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_VOIDmode))
    return -1;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
      operands[1] = x5;
      if (!call_insn_operand (operands[1], E_VOIDmode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      if (
#line 2971 "../../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn)))
        return 326; /* sibcall_value_internal */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 335; /* call_value_internal */

    case LO_SUM:
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !symbolic_operand (operands[2], E_SImode))
            return -1;
          if ((
#line 2983 "../../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
            return 327; /* sibcall_value_internal_1si */
          if (pnum_clobbers == NULL
              || !(
#line 3112 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
            return -1;
          *pnum_clobbers = 1;
          return 336; /* call_value_internal_1si */

        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !symbolic_operand (operands[2], E_DImode))
            return -1;
          if ((
#line 2983 "../../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
            return 328; /* sibcall_value_internal_1di */
          if (pnum_clobbers == NULL
              || !(
#line 3112 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
            return -1;
          *pnum_clobbers = 1;
          return 337; /* call_value_internal_1di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      switch (pattern16 (x3))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 22; /* *divsf3 */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 23; /* *divdf3 */

        case 2:
          return 26; /* *divsi3 */

        case 3:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 30; /* *divdi3 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern45 (x3, E_SFmode) != 0
                  || !
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 24; /* *recipsf3 */

            case E_DFmode:
              if (pattern45 (x3, E_DFmode) != 0
                  || !
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 25; /* *recipdf3 */

            default:
              return -1;
            }

        case SQRT:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern46 (x3, E_SFmode) != 0
                  || !(
#line 947 "../../../gcc/config/loongarch/loongarch.md"
(flag_unsafe_math_optimizations) && 
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 56; /* *rsqrtsfa */

            case E_DFmode:
              if (pattern46 (x3, E_DFmode) != 0
                  || !(
#line 947 "../../../gcc/config/loongarch/loongarch.md"
(flag_unsafe_math_optimizations) && 
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 57; /* *rsqrtdfa */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!equality_operator (operands[1], E_VOIDmode))
        return -1;
      switch (pattern29 (x1))
        {
        case 0:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 245; /* branch_equalitysi */

        case 1:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 246; /* branch_equalitydi */

        case 2:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 247; /* *branch_equalitysi_inverted */

        case 3:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 248; /* *branch_equalitydi_inverted */

        default:
          return -1;
        }

    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) == ABS)
        {
          res = recog_3 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!order_operator (operands[1], E_VOIDmode))
        return -1;
      switch (pattern29 (x1))
        {
        case 0:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 241; /* *branch_ordersi */

        case 1:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 242; /* *branch_orderdi */

        case 2:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 243; /* *branch_ordersi_inverted */

        case 3:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 244; /* *branch_orderdi_inverted */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern16 (x3))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 12; /* mulsf3 */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 13; /* muldf3 */

        case 2:
          return 14; /* mulsi3 */

        case 3:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 15; /* muldi3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 638 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 16; /* mulsidi3_64bit */

    default:
      return -1;
    }
}

static int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case ZERO_EXTRACT:
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case REG:
    case SUBREG:
    case MEM:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return 309; /* indirect_jumpsi */
          break;

        case E_DImode:
          if (register_operand (operands[0], E_DImode)
              && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return 310; /* indirect_jumpdi */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      operands[0] = x2;
      if (!register_operand (operands[0], E_FCCmode))
        return -1;
      return 139; /* movfcc */

    case LABEL_REF:
      if (GET_CODE (x2) != PC)
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (
#line 2680 "../../../gcc/config/loongarch/loongarch.md"
(!flag_pic))
        return 307; /* *jump_absolute */
      if (!
#line 2689 "../../../gcc/config/loongarch/loongarch.md"
(flag_pic))
        return -1;
      return 308; /* *jump_pic */

    default:
      return -1;
    }
}

static int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case UNSPEC_VOLATILE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (pattern40 (x1) != 0)
            return -1;
          switch (XINT (x3, 1))
            {
            case 3:
              if (!const_uimm14_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode)
                    return -1;
                  return 198; /* loongarch_csrrd_w */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 199; /* loongarch_csrrd_d */

                default:
                  return -1;
                }

            case 6:
              if (!register_operand (operands[1], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (!register_operand (operands[0], E_QImode)
                      || GET_MODE (x3) != E_QImode)
                    return -1;
                  return 204; /* loongarch_iocsrrd_b */

                case E_HImode:
                  if (!register_operand (operands[0], E_HImode)
                      || GET_MODE (x3) != E_HImode)
                    return -1;
                  return 205; /* loongarch_iocsrrd_h */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode)
                    return -1;
                  return 206; /* loongarch_iocsrrd_w */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !
#line 369 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 207; /* loongarch_iocsrrd_d */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[1] = x5;
          switch (XINT (x3, 1))
            {
            case 4:
              x6 = XVECEXP (x1, 0, 1);
              if (pattern12 (x6) != 0)
                return -1;
              x7 = XVECEXP (x3, 0, 1);
              operands[2] = x7;
              if (!const_uimm14_operand (operands[2], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode
                      || !register_operand (operands[1], E_SImode))
                    return -1;
                  return 200; /* loongarch_csrwr_w */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !register_operand (operands[1], E_DImode)
                      || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 201; /* loongarch_csrwr_d */

                default:
                  return -1;
                }

            case 41:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              x7 = XVECEXP (x3, 0, 1);
              operands[3] = x7;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              x9 = XEXP (x6, 0);
              if (!rtx_equal_p (x9, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern69 (x3, E_SImode) != 0)
                    return -1;
                  return 385; /* atomic_exchangesi */

                case E_DImode:
                  if (pattern69 (x3, E_DImode) != 0
                      || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 386; /* atomic_exchangedi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          if (XINT (x3, 1) != 5
              || pattern40 (x1) != 0)
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          x10 = XVECEXP (x3, 0, 2);
          operands[3] = x10;
          if (!const_uimm14_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern72 (x3, E_SImode) != 0)
                return -1;
              return 202; /* loongarch_csrxchg_w */

            case E_DImode:
              if (pattern72 (x3, E_DImode) != 0
                  || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 203; /* loongarch_csrxchg_d */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case PC:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != LABEL_REF)
            return -1;
          operands[0] = x3;
          x11 = XEXP (x9, 0);
          operands[1] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return -1;
              return 311; /* tablejumpsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return -1;
              return 312; /* tablejumpdi */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          operands[1] = x3;
          x8 = XEXP (x6, 1);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
            case MEM:
              operands[3] = x8;
              x9 = XEXP (x6, 0);
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern68 (E_HImode) != 0
                      || !
#line 3274 "../../../gcc/config/loongarch/loongarch.md"
(reload_completed))
                    return -1;
                  return 352; /* *join2_load_storehi */

                case E_SImode:
                  if (pattern68 (E_SImode) != 0
                      || !
#line 3274 "../../../gcc/config/loongarch/loongarch.md"
(reload_completed))
                    return -1;
                  return 353; /* *join2_load_storesi */

                case E_SFmode:
                  if (pattern68 (E_SFmode) != 0
                      || !(
#line 3274 "../../../gcc/config/loongarch/loongarch.md"
(reload_completed) && 
#line 346 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 354; /* *join2_load_storesf */

                case E_DFmode:
                  if (pattern68 (E_DFmode) != 0
                      || !(
#line 3274 "../../../gcc/config/loongarch/loongarch.md"
(reload_completed) && 
#line 347 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 355; /* *join2_load_storedf */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              x9 = XEXP (x6, 0);
              if (!rtx_equal_p (x9, operands[1]))
                return -1;
              switch (XVECLEN (x8, 0))
                {
                case 2:
                  if (XINT (x8, 1) != 40)
                    return -1;
                  x12 = XVECEXP (x8, 0, 1);
                  operands[3] = x12;
                  if (!const_int_operand (operands[3], E_SImode))
                    return -1;
                  x13 = XVECEXP (x8, 0, 0);
                  switch (GET_CODE (x13))
                    {
                    case PLUS:
                      switch (pattern71 (x8))
                        {
                        case 0:
                          return 377; /* atomic_fetch_addsi */

                        case 1:
                          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 381; /* atomic_fetch_adddi */

                        default:
                          return -1;
                        }

                    case IOR:
                      switch (pattern71 (x8))
                        {
                        case 0:
                          return 378; /* atomic_fetch_orsi */

                        case 1:
                          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 382; /* atomic_fetch_ordi */

                        default:
                          return -1;
                        }

                    case XOR:
                      switch (pattern71 (x8))
                        {
                        case 0:
                          return 379; /* atomic_fetch_xorsi */

                        case 1:
                          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 383; /* atomic_fetch_xordi */

                        default:
                          return -1;
                        }

                    case AND:
                      switch (pattern71 (x8))
                        {
                        case 0:
                          return 380; /* atomic_fetch_andsi */

                        case 1:
                          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 384; /* atomic_fetch_anddi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 4:
                  if (pnum_clobbers == NULL
                      || XINT (x8, 1) != 33)
                    return -1;
                  x13 = XVECEXP (x8, 0, 0);
                  operands[2] = x13;
                  x12 = XVECEXP (x8, 0, 1);
                  operands[3] = x12;
                  x14 = XVECEXP (x8, 0, 2);
                  operands[4] = x14;
                  if (!const_int_operand (operands[4], E_SImode))
                    return -1;
                  x15 = XVECEXP (x8, 0, 3);
                  operands[5] = x15;
                  if (!const_int_operand (operands[5], E_SImode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern73 (x8, E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 1;
                      return 387; /* atomic_cas_value_strongsi */

                    case E_DImode:
                      if (pattern73 (x8, E_DImode) != 0
                          || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 1;
                      return 388; /* atomic_cas_value_strongdi */

                    default:
                      return -1;
                    }

                case 5:
                  if (pnum_clobbers == NULL)
                    return -1;
                  x13 = XVECEXP (x8, 0, 0);
                  operands[2] = x13;
                  x12 = XVECEXP (x8, 0, 1);
                  operands[3] = x12;
                  x14 = XVECEXP (x8, 0, 2);
                  operands[4] = x14;
                  x15 = XVECEXP (x8, 0, 3);
                  operands[5] = x15;
                  x16 = XVECEXP (x8, 0, 4);
                  operands[6] = x16;
                  if (!const_int_operand (operands[6], E_SImode))
                    return -1;
                  switch (XINT (x8, 1))
                    {
                    case 33:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern74 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 1;
                          return 389; /* atomic_cas_value_cmp_and_7_si */

                        case E_DImode:
                          if (pattern74 (x8, E_DImode) != 0
                              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 1;
                          return 390; /* atomic_cas_value_cmp_and_7_di */

                        default:
                          return -1;
                        }

                    case 34:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern74 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 2;
                          return 391; /* atomic_cas_value_add_7_si */

                        case E_DImode:
                          if (pattern74 (x8, E_DImode) != 0
                              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 2;
                          return 392; /* atomic_cas_value_add_7_di */

                        default:
                          return -1;
                        }

                    case 35:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern74 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 2;
                          return 393; /* atomic_cas_value_sub_7_si */

                        case E_DImode:
                          if (pattern74 (x8, E_DImode) != 0
                              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 2;
                          return 394; /* atomic_cas_value_sub_7_di */

                        default:
                          return -1;
                        }

                    case 36:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern74 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 2;
                          return 395; /* atomic_cas_value_and_7_si */

                        case E_DImode:
                          if (pattern74 (x8, E_DImode) != 0
                              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 2;
                          return 396; /* atomic_cas_value_and_7_di */

                        default:
                          return -1;
                        }

                    case 37:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern74 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 2;
                          return 397; /* atomic_cas_value_xor_7_si */

                        case E_DImode:
                          if (pattern74 (x8, E_DImode) != 0
                              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 2;
                          return 398; /* atomic_cas_value_xor_7_di */

                        default:
                          return -1;
                        }

                    case 38:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern74 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 2;
                          return 399; /* atomic_cas_value_or_7_si */

                        case E_DImode:
                          if (pattern74 (x8, E_DImode) != 0
                              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 2;
                          return 400; /* atomic_cas_value_or_7_di */

                        default:
                          return -1;
                        }

                    case 39:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern74 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 2;
                          return 401; /* atomic_cas_value_nand_7_si */

                        case E_DImode:
                          if (pattern74 (x8, E_DImode) != 0
                              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 2;
                          return 402; /* atomic_cas_value_nand_7_di */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x17 = XEXP (x3, 0);
      if (GET_CODE (x17) != MEM)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x18 = XEXP (x17, 0);
      switch (GET_CODE (x18))
        {
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x18;
          if (!call_insn_operand (operands[1], E_VOIDmode)
              || GET_MODE (x17) != E_SImode)
            return -1;
          x19 = XEXP (x3, 1);
          operands[2] = x19;
          x6 = XVECEXP (x1, 0, 1);
          switch (GET_CODE (x6))
            {
            case SET:
              x8 = XEXP (x6, 1);
              if (GET_CODE (x8) != CALL)
                return -1;
              x20 = XEXP (x8, 0);
              if (GET_CODE (x20) != MEM
                  || GET_MODE (x20) != E_SImode)
                return -1;
              x9 = XEXP (x6, 0);
              operands[3] = x9;
              if (!register_operand (operands[3], E_VOIDmode))
                return -1;
              x21 = XEXP (x20, 0);
              if (!rtx_equal_p (x21, operands[1]))
                return -1;
              x22 = XEXP (x8, 1);
              if (!rtx_equal_p (x22, operands[2]))
                return -1;
              if (
#line 2994 "../../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn)))
                return 329; /* sibcall_value_multiple_internal */
              if (pnum_clobbers == NULL)
                return -1;
              *pnum_clobbers = 1;
              return 338; /* call_value_multiple_internal */

            case CLOBBER:
              x9 = XEXP (x6, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 1
                  || GET_MODE (x9) != E_SImode)
                return -1;
              return 335; /* call_value_internal */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x18, 0) != 2)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != CALL)
            return -1;
          x20 = XEXP (x8, 0);
          if (GET_CODE (x20) != MEM)
            return -1;
          x21 = XEXP (x20, 0);
          if (GET_CODE (x21) != UNSPEC
              || XVECLEN (x21, 0) != 2)
            return -1;
          x23 = XVECEXP (x18, 0, 0);
          operands[1] = x23;
          x24 = XVECEXP (x18, 0, 1);
          operands[2] = x24;
          x19 = XEXP (x3, 1);
          operands[3] = x19;
          x9 = XEXP (x6, 0);
          operands[4] = x9;
          if (!register_operand (operands[4], E_VOIDmode))
            return -1;
          x25 = XVECEXP (x21, 0, 0);
          if (!rtx_equal_p (x25, operands[1]))
            return -1;
          x26 = XVECEXP (x21, 0, 1);
          if (!rtx_equal_p (x26, operands[2]))
            return -1;
          x22 = XEXP (x8, 1);
          if (!rtx_equal_p (x22, operands[3]))
            return -1;
          switch (XINT (x18, 1))
            {
            case 31:
              if (XINT (x21, 1) != 31)
                return -1;
              switch (GET_MODE (x17))
                {
                case E_SImode:
                  if (pattern78 (x1, E_SImode) != 0
                      || !(
#line 3012 "../../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                    return -1;
                  return 330; /* sibcall_value_multiple_internal_1si */

                case E_DImode:
                  if (pattern78 (x1, E_DImode) != 0
                      || !(
#line 3012 "../../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                    return -1;
                  return 331; /* sibcall_value_multiple_internal_1di */

                default:
                  return -1;
                }

            case 32:
              if (pnum_clobbers == NULL
                  || XINT (x21, 1) != 32)
                return -1;
              switch (GET_MODE (x17))
                {
                case E_SImode:
                  if (pattern78 (x1, E_SImode) != 0
                      || !(
#line 3143 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 339; /* call_value_multiple_internal_1si */

                case E_DImode:
                  if (pattern78 (x1, E_DImode) != 0
                      || !(
#line 3143 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 340; /* call_value_multiple_internal_1di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case LO_SUM:
          x6 = XVECEXP (x1, 0, 1);
          if (pattern23 (x6) != 0)
            return -1;
          x27 = XEXP (x18, 0);
          operands[1] = x27;
          x28 = XEXP (x18, 1);
          operands[2] = x28;
          x19 = XEXP (x3, 1);
          operands[3] = x19;
          switch (GET_MODE (x17))
            {
            case E_SImode:
              if (GET_MODE (x18) != E_SImode
                  || !register_operand (operands[1], E_SImode)
                  || !symbolic_operand (operands[2], E_SImode)
                  || !(
#line 3112 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                return -1;
              return 336; /* call_value_internal_1si */

            case E_DImode:
              if (GET_MODE (x18) != E_DImode
                  || !register_operand (operands[1], E_DImode)
                  || !symbolic_operand (operands[2], E_DImode)
                  || !(
#line 3112 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                return -1;
              return 337; /* call_value_internal_1di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern22 (x1, SIGN_EXTEND) != 0
          || !
#line 3320 "../../../gcc/config/loongarch/loongarch.md"
(reload_completed))
        return -1;
      return 356; /* *join2_loadhi */

    case ZERO_EXTEND:
      if (pattern22 (x1, ZERO_EXTEND) != 0
          || !
#line 3320 "../../../gcc/config/loongarch/loongarch.md"
(reload_completed))
        return -1;
      return 357; /* *join2_loadhi */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 43
          || GET_MODE (x3) != E_BLKmode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XVECEXP (x1, 0, 1);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      return 366; /* mem_thread_fence_1 */

    default:
      return -1;
    }
}

static int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      return recog_11 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_10 (x1, insn, pnum_clobbers);

    case MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern16 (x2))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 7; /* subsf3 */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 8; /* subdf3 */

        case 2:
          return 9; /* subsi3 */

        case 3:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 10; /* subdi3 */

        default:
          return -1;
        }

    case MULT:
      return recog_18 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != LSHIFTRT)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          switch (pattern43 (x2, SIGN_EXTEND))
            {
            case 0:
              if (!
#line 687 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 18; /* muldi3_highpart */

            case 1:
              if (!
#line 717 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 20; /* mulsi3_highpart */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern43 (x2, ZERO_EXTEND))
            {
            case 0:
              if (!
#line 687 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 19; /* umuldi3_highpart */

            case 1:
              if (!
#line 717 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 21; /* umulsi3_highpart */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      return recog_16 (x1, insn, pnum_clobbers);

    case UDIV:
      switch (pattern1 (x1))
        {
        case 0:
          return 27; /* *udivsi3 */

        case 1:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 31; /* *udivdi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern1 (x1))
        {
        case 0:
          return 28; /* *modsi3 */

        case 1:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 32; /* *moddi3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern1 (x1))
        {
        case 0:
          return 29; /* *umodsi3 */

        case 1:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 33; /* *umoddi3 */

        default:
          return -1;
        }

    case FMA:
      return recog_12 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_7 (x1, insn, pnum_clobbers);

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern11 (x2))
            {
            case 0:
              if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 54; /* sqrtsf2 */

            case 1:
              if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 55; /* sqrtdf2 */

            default:
              return -1;
            }

        case DIV:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern44 (x2, E_SFmode) != 0
                  || !(
#line 957 "../../../gcc/config/loongarch/loongarch.md"
(flag_unsafe_math_optimizations) && 
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 58; /* *rsqrtsfb */

            case E_DFmode:
              if (pattern44 (x2, E_DFmode) != 0
                  || !(
#line 957 "../../../gcc/config/loongarch/loongarch.md"
(flag_unsafe_math_optimizations) && 
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 59; /* *rsqrtdfb */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern11 (x2))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 60; /* abssf2 */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 61; /* absdf2 */

        default:
          return -1;
        }

    case CLZ:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern3 (x2))
        {
        case 0:
          return 62; /* clzsi2 */

        case 1:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 63; /* clzdi2 */

        default:
          return -1;
        }

    case CTZ:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern3 (x2))
        {
        case 0:
          return 64; /* ctzsi2 */

        case 1:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 65; /* ctzdi2 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 66; /* smaxsf3 */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 67; /* smaxdf3 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern2 (x1))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 68; /* sminsf3 */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 69; /* smindf3 */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_6 (x1, insn, pnum_clobbers);

    case IF_THEN_ELSE:
      return recog_17 (x1, insn, pnum_clobbers);

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern3 (x2))
        {
        case 0:
          return 80; /* one_cmplsi2 */

        case 1:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 81; /* one_cmpldi2 */

        default:
          return -1;
        }

    case AND:
      return recog_9 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_14 (x1, insn, pnum_clobbers);

    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern34 (x2, E_SImode) != 0)
            return -1;
          return 86; /* xorsi3 */

        case E_DImode:
          if (pattern34 (x2, E_DImode) != 0
              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 89; /* xordi3 */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 1182 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 99; /* truncdfsf2 */

    case ZERO_EXTEND:
      return recog_13 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 1317 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 117; /* extendsfdf2 */

    case FIX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern32 (x2, E_SImode))
            {
            case 0:
              if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 118; /* fix_truncsfsi2 */

            case 1:
              if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 120; /* fix_truncdfsi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern32 (x2, E_DImode))
            {
            case 0:
              if (!(
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 119; /* fix_truncsfdi2 */

            case 1:
              if (!(
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 121; /* fix_truncdfdi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          switch (pattern5 (x2, E_DFmode))
            {
            case 0:
              if (!
#line 1345 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 122; /* floatsidf2 */

            case 1:
              if (!
#line 1354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 123; /* floatdidf2 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern5 (x2, E_SFmode))
            {
            case 0:
              if (!
#line 1363 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 124; /* floatsisf2 */

            case 1:
              if (!
#line 1372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 125; /* floatdisf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      switch (pattern3 (x2))
        {
        case 0:
          if (!(
#line 1570 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[1], INTVAL (operands[2]),
			    INTVAL (operands[3]))) && 
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
            return -1;
          return 126; /* *extzvsi */

        case 1:
          if (!(
#line 1570 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[1], INTVAL (operands[2]),
			    INTVAL (operands[3]))) && 
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 127; /* *extzvdi */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_19 (x1, insn, pnum_clobbers);

    case LO_SUM:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern35 (x2, E_SImode) != 0
              || !(
#line 1915 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_EXPLICIT_RELOCS) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
            return -1;
          return 152; /* *lowsi */

        case E_DImode:
          if (pattern35 (x2, E_DImode) != 0
              || !(
#line 1915 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_EXPLICIT_RELOCS) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
            return -1;
          return 153; /* *lowdi */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      return recog_8 (x1, insn, pnum_clobbers);

    case ASHIFT:
      switch (pattern4 (x1))
        {
        case 0:
          return 218; /* ashlsi3 */

        case 1:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 221; /* ashldi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern4 (x1))
        {
        case 0:
          return 219; /* ashrsi3 */

        case 1:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 222; /* ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern4 (x1))
        {
        case 0:
          return 220; /* lshrsi3 */

        case 1:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 223; /* lshrdi3 */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern4 (x1))
        {
        case 0:
          return 227; /* rotrsi3 */

        case 1:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 228; /* rotrdi3 */

        default:
          return -1;
        }

    case BSWAP:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 233; /* bswaphi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 234; /* bswapsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 2409 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 235; /* bswapdi2 */

        default:
          return -1;
        }

    case EQ:
      switch (pattern9 (x1))
        {
        case 0:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 249; /* *seq_zero_sisi */

        case 1:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 250; /* *seq_zero_disi */

        case 2:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 251; /* *seq_zero_didi */

        case 3:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 283; /* seq_sf_using_FCCmode */

        case 4:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 297; /* seq_df_using_FCCmode */

        default:
          return -1;
        }

    case NE:
      switch (pattern9 (x1))
        {
        case 0:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 252; /* *sne_zero_sisi */

        case 1:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 253; /* *sne_zero_disi */

        case 2:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 254; /* *sne_zero_didi */

        case 3:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 288; /* sne_sf_using_FCCmode */

        case 4:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 302; /* sne_df_using_FCCmode */

        default:
          return -1;
        }

    case GT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern36 (x2))
            {
            case 0:
              if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 255; /* *sgt_sisi */

            case 1:
              if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 257; /* *sgt_disi */

            default:
              return -1;
            }

        case E_DImode:
          if (pattern37 (x2) != 0
              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 259; /* *sgt_didi */

        case E_FCCmode:
          switch (pattern8 (x2))
            {
            case 0:
              if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 290; /* sgt_sf_using_FCCmode */

            case 1:
              if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 304; /* sgt_df_using_FCCmode */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GTU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern36 (x2))
            {
            case 0:
              if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 256; /* *sgtu_sisi */

            case 1:
              if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 258; /* *sgtu_disi */

            default:
              return -1;
            }

        case E_DImode:
          if (pattern37 (x2) != 0
              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 260; /* *sgtu_didi */

        default:
          return -1;
        }

    case GE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
          if (XWINT (x8, 0) != 1L)
            return -1;
          switch (pattern6 (x2))
            {
            case 0:
              if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 261; /* *sge_sisi */

            case 1:
              if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 263; /* *sge_disi */

            case 2:
              if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 265; /* *sge_didi */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x8;
          switch (pattern8 (x2))
            {
            case 0:
              if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 289; /* sge_sf_using_FCCmode */

            case 1:
              if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 303; /* sge_df_using_FCCmode */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GEU:
      x8 = XEXP (x2, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern6 (x2))
        {
        case 0:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 262; /* *sgeu_sisi */

        case 1:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 264; /* *sgeu_disi */

        case 2:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 266; /* *sgeu_didi */

        default:
          return -1;
        }

    case LT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern38 (x2))
            {
            case 0:
              if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 267; /* *slt_sisi */

            case 1:
              if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 269; /* *slt_disi */

            default:
              return -1;
            }

        case E_DImode:
          if (pattern39 (x2, E_DImode) != 0
              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 271; /* *slt_didi */

        case E_FCCmode:
          switch (pattern8 (x2))
            {
            case 0:
              if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 284; /* slt_sf_using_FCCmode */

            case 1:
              if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 298; /* slt_df_using_FCCmode */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern38 (x2))
            {
            case 0:
              if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 268; /* *sltu_sisi */

            case 1:
              if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 270; /* *sltu_disi */

            default:
              return -1;
            }

        case E_DImode:
          if (pattern39 (x2, E_DImode) != 0
              || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 272; /* *sltu_didi */

        default:
          return -1;
        }

    case LE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (pattern33 (x2))
            {
            case 0:
              if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 273; /* *sle_sisi */

            case 1:
              if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 275; /* *sle_disi */

            case 2:
              if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 277; /* *sle_didi */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern8 (x2))
            {
            case 0:
              if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 285; /* sle_sf_using_FCCmode */

            case 1:
              if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 299; /* sle_df_using_FCCmode */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LEU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (pattern33 (x2))
        {
        case 0:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 274; /* *sleu_sisi */

        case 1:
          if (!
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 276; /* *sleu_disi */

        case 2:
          if (!
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 278; /* *sleu_didi */

        default:
          return -1;
        }

    case UNORDERED:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 279; /* sunordered_sf_using_FCCmode */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 293; /* sunordered_df_using_FCCmode */

        default:
          return -1;
        }

    case UNEQ:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 280; /* suneq_sf_using_FCCmode */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 294; /* suneq_df_using_FCCmode */

        default:
          return -1;
        }

    case UNLT:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 281; /* sunlt_sf_using_FCCmode */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 295; /* sunlt_df_using_FCCmode */

        default:
          return -1;
        }

    case UNLE:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 282; /* sunle_sf_using_FCCmode */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 296; /* sunle_df_using_FCCmode */

        default:
          return -1;
        }

    case ORDERED:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 286; /* sordered_sf_using_FCCmode */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 300; /* sordered_df_using_FCCmode */

        default:
          return -1;
        }

    case LTGT:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 287; /* sltgt_sf_using_FCCmode */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 301; /* sltgt_df_using_FCCmode */

        default:
          return -1;
        }

    case UNGE:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 291; /* sunge_sf_using_FCCmode */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 305; /* sunge_df_using_FCCmode */

        default:
          return -1;
        }

    case UNGT:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 372 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 292; /* sungt_sf_using_FCCmode */

        case 1:
          if (!
#line 373 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 306; /* sungt_df_using_FCCmode */

        default:
          return -1;
        }

    case CALL:
      return recog_15 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case TRAP_IF:
      x2 = XEXP (x1, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 1; /* trap */

    case SET:
      return recog_21 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x4 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x4))
            {
            case UNSPEC_VOLATILE:
              x5 = XVECEXP (x1, 0, 1);
              if (pattern12 (x5) != 0)
                return -1;
              switch (XVECLEN (x4, 0))
                {
                case 1:
                  if (GET_MODE (x4) != E_SImode)
                    return -1;
                  x6 = XVECEXP (x4, 0, 0);
                  operands[0] = x6;
                  if (!const_uimm15_operand (operands[0], E_VOIDmode))
                    return -1;
                  switch (XINT (x4, 1))
                    {
                    case 2:
                      return 191; /* loongarch_ibar */

                    case 1:
                      return 192; /* loongarch_dbar */

                    case 18:
                      return 194; /* loongarch_syscall */

                    case 19:
                      return 195; /* loongarch_break */

                    default:
                      return -1;
                    }

                case 2:
                  x6 = XVECEXP (x4, 0, 0);
                  operands[0] = x6;
                  x7 = XVECEXP (x4, 0, 1);
                  operands[1] = x7;
                  switch (XINT (x4, 1))
                    {
                    case 7:
                      if (!register_operand (operands[1], E_SImode))
                        return -1;
                      switch (GET_MODE (x4))
                        {
                        case E_QImode:
                          if (!register_operand (operands[0], E_QImode))
                            return -1;
                          return 208; /* loongarch_iocsrwr_b */

                        case E_HImode:
                          if (!register_operand (operands[0], E_HImode))
                            return -1;
                          return 209; /* loongarch_iocsrwr_h */

                        case E_SImode:
                          if (!register_operand (operands[0], E_SImode))
                            return -1;
                          return 210; /* loongarch_iocsrwr_w */

                        case E_DImode:
                          if (!register_operand (operands[0], E_DImode)
                              || !
#line 369 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 211; /* loongarch_iocsrwr_d */

                        default:
                          return -1;
                        }

                    case 10:
                      if (!const_uimm5_operand (operands[1], E_VOIDmode))
                        return -1;
                      switch (GET_MODE (x4))
                        {
                        case E_SImode:
                          if (!register_operand (operands[0], E_SImode)
                              || !
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                            return -1;
                          return 216; /* loongarch_ldpte_w */

                        case E_DImode:
                          if (!register_operand (operands[0], E_DImode)
                              || !
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 217; /* loongarch_ldpte_d */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 3:
                  x6 = XVECEXP (x4, 0, 0);
                  operands[0] = x6;
                  x7 = XVECEXP (x4, 0, 1);
                  operands[1] = x7;
                  x8 = XVECEXP (x4, 0, 2);
                  operands[2] = x8;
                  switch (XINT (x4, 1))
                    {
                    case 8:
                      if (!const_uimm5_operand (operands[0], E_VOIDmode)
                          || !const_imm12_operand (operands[2], E_VOIDmode))
                        return -1;
                      switch (GET_MODE (x4))
                        {
                        case E_SImode:
                          if (!register_operand (operands[1], E_SImode)
                              || !
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                            return -1;
                          return 212; /* loongarch_cacop_w */

                        case E_DImode:
                          if (!register_operand (operands[1], E_DImode)
                              || !
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 213; /* loongarch_cacop_d */

                        default:
                          return -1;
                        }

                    case 9:
                      if (!const_uimm5_operand (operands[2], E_VOIDmode))
                        return -1;
                      switch (GET_MODE (x4))
                        {
                        case E_SImode:
                          if (!register_operand (operands[0], E_SImode)
                              || !register_operand (operands[1], E_SImode)
                              || !
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                            return -1;
                          return 214; /* loongarch_lddir_w */

                        case E_DImode:
                          if (!register_operand (operands[0], E_DImode)
                              || !register_operand (operands[1], E_DImode)
                              || !
#line 354 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 215; /* loongarch_lddir_d */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case SET:
              return recog_20 (x1, insn, pnum_clobbers);

            case RETURN:
              x5 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x5))
                {
                case USE:
                  x9 = XEXP (x5, 0);
                  operands[0] = x9;
                  if (!pmode_register_operand (operands[0], E_VOIDmode))
                    return -1;
                  return 318; /* return_internal */

                case UNSPEC_VOLATILE:
                  if (XVECLEN (x5, 0) != 1
                      || XINT (x5, 1) != 11)
                    return -1;
                  x10 = XVECEXP (x5, 0, 0);
                  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  return 320; /* loongarch_ertn */

                default:
                  return -1;
                }

            case SIMPLE_RETURN:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != USE)
                return -1;
              x9 = XEXP (x5, 0);
              operands[0] = x9;
              if (!pmode_register_operand (operands[0], E_VOIDmode))
                return -1;
              return 319; /* simple_return_internal */

            case UNSPEC:
              if (XVECLEN (x4, 0) != 1
                  || XINT (x4, 1) != 12)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x6 = XVECEXP (x4, 0, 0);
              operands[0] = x6;
              x9 = XEXP (x5, 0);
              operands[1] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !scratch_operand (operands[1], E_SImode)
                      || !
#line 2857 "../../../gcc/config/loongarch/loongarch.md"
(! TARGET_64BIT))
                    return -1;
                  return 321; /* eh_set_ra_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !scratch_operand (operands[1], E_DImode)
                      || !
#line 2863 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 322; /* eh_set_ra_di */

                default:
                  return -1;
                }

            case CALL:
              x11 = XEXP (x4, 0);
              if (GET_CODE (x11) != MEM)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (pattern23 (x5) != 0)
                return -1;
              x12 = XEXP (x11, 0);
              switch (GET_CODE (x12))
                {
                case CONST:
                case REG:
                case SUBREG:
                case LABEL_REF:
                case SYMBOL_REF:
                  operands[0] = x12;
                  if (!call_insn_operand (operands[0], E_VOIDmode)
                      || GET_MODE (x11) != E_SImode)
                    return -1;
                  x13 = XEXP (x4, 1);
                  operands[1] = x13;
                  return 332; /* call_internal */

                case LO_SUM:
                  x14 = XEXP (x12, 0);
                  operands[0] = x14;
                  x15 = XEXP (x12, 1);
                  operands[1] = x15;
                  x13 = XEXP (x4, 1);
                  operands[2] = x13;
                  switch (GET_MODE (x11))
                    {
                    case E_SImode:
                      if (GET_MODE (x12) != E_SImode
                          || !register_operand (operands[0], E_SImode)
                          || !symbolic_operand (operands[1], E_SImode)
                          || !(
#line 3049 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                        return -1;
                      return 333; /* call_internal_1si */

                    case E_DImode:
                      if (GET_MODE (x12) != E_DImode
                          || !register_operand (operands[0], E_DImode)
                          || !symbolic_operand (operands[1], E_DImode)
                          || !(
#line 3049 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                        return -1;
                      return 334; /* call_internal_1di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          x4 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x16 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x16) != CLOBBER)
            return -1;
          x11 = XEXP (x4, 0);
          operands[0] = x11;
          x13 = XEXP (x4, 1);
          switch (GET_CODE (x13))
            {
            case CALL:
              x17 = XEXP (x13, 0);
              if (GET_CODE (x17) != MEM)
                return -1;
              x18 = XEXP (x5, 1);
              if (GET_CODE (x18) != CALL)
                return -1;
              x19 = XEXP (x18, 0);
              if (GET_CODE (x19) != MEM)
                return -1;
              x20 = XEXP (x16, 0);
              if (GET_CODE (x20) != REG
                  || REGNO (x20) != 1
                  || GET_MODE (x20) != E_SImode
                  || !register_operand (operands[0], E_VOIDmode))
                return -1;
              x9 = XEXP (x5, 0);
              if (!register_operand (x9, E_VOIDmode))
                return -1;
              x21 = XEXP (x17, 0);
              switch (GET_CODE (x21))
                {
                case CONST:
                case REG:
                case SUBREG:
                case LABEL_REF:
                case SYMBOL_REF:
                  operands[1] = x21;
                  if (!call_insn_operand (operands[1], E_VOIDmode)
                      || GET_MODE (x17) != E_SImode)
                    return -1;
                  x22 = XEXP (x13, 1);
                  operands[2] = x22;
                  operands[3] = x9;
                  if (GET_MODE (x19) != E_SImode)
                    return -1;
                  x23 = XEXP (x19, 0);
                  if (!rtx_equal_p (x23, operands[1]))
                    return -1;
                  x24 = XEXP (x18, 1);
                  if (!rtx_equal_p (x24, operands[2]))
                    return -1;
                  return 338; /* call_value_multiple_internal */

                case UNSPEC:
                  if (XVECLEN (x21, 0) != 2
                      || XINT (x21, 1) != 32)
                    return -1;
                  x23 = XEXP (x19, 0);
                  if (GET_CODE (x23) != UNSPEC
                      || XVECLEN (x23, 0) != 2
                      || XINT (x23, 1) != 32)
                    return -1;
                  x25 = XVECEXP (x21, 0, 0);
                  operands[1] = x25;
                  x26 = XVECEXP (x21, 0, 1);
                  operands[2] = x26;
                  x22 = XEXP (x13, 1);
                  operands[3] = x22;
                  operands[4] = x9;
                  x27 = XVECEXP (x23, 0, 0);
                  if (!rtx_equal_p (x27, operands[1]))
                    return -1;
                  x28 = XVECEXP (x23, 0, 1);
                  if (!rtx_equal_p (x28, operands[2]))
                    return -1;
                  x24 = XEXP (x18, 1);
                  if (!rtx_equal_p (x24, operands[3]))
                    return -1;
                  switch (GET_MODE (x17))
                    {
                    case E_SImode:
                      if (pattern78 (x1, E_SImode) != 0
                          || !(
#line 3143 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                        return -1;
                      return 339; /* call_value_multiple_internal_1si */

                    case E_DImode:
                      if (pattern78 (x1, E_DImode) != 0
                          || !(
#line 3143 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                        return -1;
                      return 340; /* call_value_multiple_internal_1di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case SUBREG:
            case MEM:
              operands[1] = x13;
              x18 = XEXP (x5, 1);
              if (GET_CODE (x18) != UNSPEC_VOLATILE
                  || XINT (x18, 1) != 33)
                return -1;
              x9 = XEXP (x5, 0);
              if (!rtx_equal_p (x9, operands[1]))
                return -1;
              switch (XVECLEN (x18, 0))
                {
                case 4:
                  x29 = XVECEXP (x18, 0, 0);
                  operands[2] = x29;
                  x30 = XVECEXP (x18, 0, 1);
                  operands[3] = x30;
                  x31 = XVECEXP (x18, 0, 2);
                  operands[4] = x31;
                  if (!const_int_operand (operands[4], E_SImode))
                    return -1;
                  x32 = XVECEXP (x18, 0, 3);
                  operands[5] = x32;
                  if (!const_int_operand (operands[5], E_SImode))
                    return -1;
                  x20 = XEXP (x16, 0);
                  operands[6] = x20;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern75 (x18, E_SImode) != 0)
                        return -1;
                      return 387; /* atomic_cas_value_strongsi */

                    case E_DImode:
                      if (pattern75 (x18, E_DImode) != 0
                          || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 388; /* atomic_cas_value_strongdi */

                    default:
                      return -1;
                    }

                case 5:
                  x29 = XVECEXP (x18, 0, 0);
                  operands[2] = x29;
                  x30 = XVECEXP (x18, 0, 1);
                  operands[3] = x30;
                  x31 = XVECEXP (x18, 0, 2);
                  operands[4] = x31;
                  x32 = XVECEXP (x18, 0, 3);
                  operands[5] = x32;
                  x33 = XVECEXP (x18, 0, 4);
                  operands[6] = x33;
                  if (!const_int_operand (operands[6], E_SImode))
                    return -1;
                  x20 = XEXP (x16, 0);
                  operands[7] = x20;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern76 (x18, E_SImode) != 0)
                        return -1;
                      return 389; /* atomic_cas_value_cmp_and_7_si */

                    case E_DImode:
                      if (pattern76 (x18, E_DImode) != 0
                          || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 390; /* atomic_cas_value_cmp_and_7_di */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4:
          x4 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x18 = XEXP (x5, 1);
          if (GET_CODE (x18) != UNSPEC_VOLATILE
              || XVECLEN (x18, 0) != 5)
            return -1;
          x16 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x16) != CLOBBER)
            return -1;
          x34 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x34) != CLOBBER)
            return -1;
          x11 = XEXP (x4, 0);
          operands[0] = x11;
          x13 = XEXP (x4, 1);
          operands[1] = x13;
          x29 = XVECEXP (x18, 0, 0);
          operands[2] = x29;
          x30 = XVECEXP (x18, 0, 1);
          operands[3] = x30;
          x31 = XVECEXP (x18, 0, 2);
          operands[4] = x31;
          x32 = XVECEXP (x18, 0, 3);
          operands[5] = x32;
          x33 = XVECEXP (x18, 0, 4);
          operands[6] = x33;
          if (!const_int_operand (operands[6], E_SImode))
            return -1;
          x20 = XEXP (x16, 0);
          operands[7] = x20;
          x35 = XEXP (x34, 0);
          operands[8] = x35;
          x9 = XEXP (x5, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (XINT (x18, 1))
            {
            case 34:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern77 (x18, E_SImode) != 0)
                    return -1;
                  return 391; /* atomic_cas_value_add_7_si */

                case E_DImode:
                  if (pattern77 (x18, E_DImode) != 0
                      || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 392; /* atomic_cas_value_add_7_di */

                default:
                  return -1;
                }

            case 35:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern77 (x18, E_SImode) != 0)
                    return -1;
                  return 393; /* atomic_cas_value_sub_7_si */

                case E_DImode:
                  if (pattern77 (x18, E_DImode) != 0
                      || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 394; /* atomic_cas_value_sub_7_di */

                default:
                  return -1;
                }

            case 36:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern77 (x18, E_SImode) != 0)
                    return -1;
                  return 395; /* atomic_cas_value_and_7_si */

                case E_DImode:
                  if (pattern77 (x18, E_DImode) != 0
                      || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 396; /* atomic_cas_value_and_7_di */

                default:
                  return -1;
                }

            case 37:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern77 (x18, E_SImode) != 0)
                    return -1;
                  return 397; /* atomic_cas_value_xor_7_si */

                case E_DImode:
                  if (pattern77 (x18, E_DImode) != 0
                      || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 398; /* atomic_cas_value_xor_7_di */

                default:
                  return -1;
                }

            case 38:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern77 (x18, E_SImode) != 0)
                    return -1;
                  return 399; /* atomic_cas_value_or_7_si */

                case E_DImode:
                  if (pattern77 (x18, E_DImode) != 0
                      || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 400; /* atomic_cas_value_or_7_di */

                default:
                  return -1;
                }

            case 39:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern77 (x18, E_SImode) != 0)
                    return -1;
                  return 401; /* atomic_cas_value_nand_7_si */

                case E_DImode:
                  if (pattern77 (x18, E_DImode) != 0
                      || !
#line 336 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 402; /* atomic_cas_value_nand_7_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x4 = XVECEXP (x1, 0, 0);
          operands[0] = x4;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          switch (XINT (x1, 1))
            {
            case 16:
              if (GET_MODE (x1) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 2173 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 196; /* loongarch_asrtle_d */

            case 17:
              if (GET_MODE (x1) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 2182 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 197; /* loongarch_asrtgt_d */

            case 14:
              if (!const_uimm5_operand (operands[0], E_VOIDmode)
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 3198 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 343; /* loongarch_movgr2fcsr */

            default:
              return -1;
            }

        case 1:
          if (XINT (x1, 1) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 313; /* blockage */

        default:
          return -1;
        }

    case RETURN:
      return 316; /* *return */

    case SIMPLE_RETURN:
      return 317; /* *simple_return */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 12)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !
#line 2857 "../../../gcc/config/loongarch/loongarch.md"
(! TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 321; /* eh_set_ra_si */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !
#line 2863 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 322; /* eh_set_ra_di */

        default:
          return -1;
        }

    case CALL:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != MEM)
        return -1;
      x36 = XEXP (x2, 0);
      switch (GET_CODE (x36))
        {
        case CONST:
        case REG:
        case SUBREG:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[0] = x36;
          if (!call_insn_operand (operands[0], E_VOIDmode)
              || GET_MODE (x2) != E_SImode)
            return -1;
          x3 = XEXP (x1, 1);
          operands[1] = x3;
          if (
#line 2908 "../../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn)))
            return 323; /* sibcall_internal */
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 332; /* call_internal */

        case LO_SUM:
          x37 = XEXP (x36, 0);
          operands[0] = x37;
          x38 = XEXP (x36, 1);
          operands[1] = x38;
          x3 = XEXP (x1, 1);
          operands[2] = x3;
          switch (GET_MODE (x2))
            {
            case E_SImode:
              if (GET_MODE (x36) != E_SImode
                  || !register_operand (operands[0], E_SImode)
                  || !symbolic_operand (operands[1], E_SImode))
                return -1;
              if ((
#line 2919 "../../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                return 324; /* sibcall_internal_1si */
              if (pnum_clobbers == NULL
                  || !(
#line 3049 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == SImode)))
                return -1;
              *pnum_clobbers = 1;
              return 333; /* call_internal_1si */

            case E_DImode:
              if (GET_MODE (x36) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || !symbolic_operand (operands[1], E_DImode))
                return -1;
              if ((
#line 2919 "../../../gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn) && TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                return 325; /* sibcall_internal_1di */
              if (pnum_clobbers == NULL
                  || !(
#line 3049 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_CMODEL_MEDIUM) && 
#line 351 "../../../gcc/config/loongarch/loongarch.md"
(Pmode == DImode)))
                return -1;
              *pnum_clobbers = 1;
              return 334; /* call_internal_1di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 341; /* nop */

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x3) == E_DImode
              && register_operand (operands[0], E_DImode))
            {
              x4 = XEXP (x3, 0);
              operands[1] = x4;
              if (nonimmediate_operand (operands[1], E_SImode)
                  && (
#line 1203 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 1209 "../../../gcc/config/loongarch/loongarch.md"
( reload_completed
   && MEM_P (operands[1])
   && (loongarch_14bit_shifted_offset_address_p (XEXP (operands[1], 0), SImode)
       && !loongarch_12bit_offset_address_p (XEXP (operands[1], 0), SImode))
   && !paradoxical_subreg_p (operands[0]))))
                return gen_split_1 (insn, operands);
            }
          break;

        case BSWAP:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          switch (pattern3 (x3))
            {
            case 0:
              return gen_split_2 (insn, operands);

            case 1:
              return gen_split_3 (insn, operands);

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    case PARALLEL:
      if (XVECLEN (x1, 0) == 2)
        {
          x5 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x5) == UNSPEC
              && XVECLEN (x5, 0) == 1
              && XINT (x5, 1) == 12)
            {
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) == CLOBBER)
                {
                  x7 = XVECEXP (x5, 0, 0);
                  operands[0] = x7;
                  if (register_operand (operands[0], E_VOIDmode))
                    {
                      x8 = XEXP (x6, 0);
                      operands[1] = x8;
                      if (scratch_operand (operands[1], E_VOIDmode)
                          && 
#line 2869 "../../../gcc/config/loongarch/loongarch.md"
(reload_completed))
                        return gen_split_4 (insn, operands);
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[0] = x1;
  if (!small_data_pattern (operands[0], E_VOIDmode)
      || !
#line 3261 "../../../gcc/config/loongarch/loongarch.md"
(reload_completed))
    return NULL;
  return gen_split_5 (insn, operands);
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && non_volatile_mem_operand (operands[1], E_HImode)
              && register_operand (operands[2], E_HImode)
              && non_volatile_mem_operand (operands[3], E_HImode)
              && 
#line 3294 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_1 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!memory_operand (operands[0], E_HImode)
              || !register_operand (operands[1], E_HImode)
              || !memory_operand (operands[2], E_HImode)
              || !register_operand (operands[3], E_HImode)
              || !
#line 3307 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_5 (insn, operands);

        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && non_volatile_mem_operand (operands[1], E_SImode)
              && register_operand (operands[2], E_SImode)
              && non_volatile_mem_operand (operands[3], E_SImode)
              && 
#line 3294 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SImode, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_2 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode)
              || !memory_operand (operands[2], E_SImode)
              || !register_operand (operands[3], E_SImode)
              || !
#line 3307 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SImode, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_6 (insn, operands);

        case E_SFmode:
          if (register_operand (operands[0], E_SFmode)
              && non_volatile_mem_operand (operands[1], E_SFmode)
              && register_operand (operands[2], E_SFmode)
              && non_volatile_mem_operand (operands[3], E_SFmode)
              && (
#line 3294 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SFmode, true)) && 
#line 346 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_3 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!memory_operand (operands[0], E_SFmode)
              || !register_operand (operands[1], E_SFmode)
              || !memory_operand (operands[2], E_SFmode)
              || !register_operand (operands[3], E_SFmode)
              || !(
#line 3307 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SFmode, false)) && 
#line 346 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_7 (insn, operands);

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode)
              && non_volatile_mem_operand (operands[1], E_DFmode)
              && register_operand (operands[2], E_DFmode)
              && non_volatile_mem_operand (operands[3], E_DFmode)
              && (
#line 3294 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, DFmode, true)) && 
#line 347 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_4 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!memory_operand (operands[0], E_DFmode)
              || !register_operand (operands[1], E_DFmode)
              || !memory_operand (operands[2], E_DFmode)
              || !register_operand (operands[3], E_DFmode)
              || !(
#line 3307 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, DFmode, false)) && 
#line 347 "../../../gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_8 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (pattern41 (x5, SIGN_EXTEND) != 0
          || !
#line 3339 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_9 (insn, operands);

    case ZERO_EXTEND:
      if (pattern41 (x5, ZERO_EXTEND) != 0
          || !
#line 3339 "../../../gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_10 (insn, operands);

    default:
      return NULL;
    }
}
